// LaserDeskDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "LaserDesk.h"
#include "LaserDeskDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CLaserDeskApp         theApp;
extern RasHangUpPtr          dllRasHangUp;
extern RasEnumConnectionsPtr dllRasEnumConnections;
extern RasDialDlgPtr         dllRasDialDlg;

static UINT Baudrates[] = {19200, 38400, 57600, 115200};


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLaserDeskDlg Dialogfeld

CLaserDeskDlg::CLaserDeskDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLaserDeskDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLaserDeskDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    m_pLaserConfigThread = NULL;
    m_pLaserTestThread   = NULL;

    m_hRASConn = NULL;

    m_AutoMode = false;
}

void CLaserDeskDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLaserDeskDlg)
		// HINWEIS: Der Klassenassistent fgt an dieser Stelle DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLaserDeskDlg, CDialog)
	//{{AFX_MSG_MAP(CLaserDeskDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMPORT, OnChangeCOMPort)
	ON_CBN_SELCHANGE(IDC_BAUDRATE, OnChangeBaudrate)
	ON_CBN_SELCHANGE(IDC_SENSITIVITY, OnChangeSensitivity)
	ON_EN_CHANGE(IDC_RASLINKNAME, OnChangeRASLinkName)
	ON_EN_CHANGE(IDC_RUNPROG, OnChangeRunProg)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_RUNINVISIBLE, OnRunInvisible)
	ON_BN_CLICKED(IDC_SAVECFG, OnSaveCfg)
	ON_BN_CLICKED(IDC_CONFIG, OnConfigLaser)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLaserDeskDlg Nachrichten-Handler

BOOL CLaserDeskDlg::OnInitDialog()
{
    DWORD status;

	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
    SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
    SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
    m_COMPortNo = theApp.GetProfileInt("Settings", "COM Port", 0);
    ((CComboBox*)GetDlgItem(IDC_COMPORT))->SetCurSel(m_COMPortNo);

    m_Baudrate = theApp.GetProfileInt("Settings", "Baudrate", 3);
    ((CComboBox*)GetDlgItem(IDC_BAUDRATE))->SetCurSel(m_Baudrate);

    m_Sensitivity = theApp.GetProfileInt("Settings", "Sensitivity", 3);
    ((CComboBox*)GetDlgItem(IDC_SENSITIVITY))->SetCurSel(m_Sensitivity);

    m_RASLinkName = theApp.GetProfileString("Settings", "RAS Link Name", "");
    SetDlgItemText(IDC_RASLINKNAME, m_RASLinkName);

    m_RunProgram = theApp.GetProfileString("Settings", "Run Program", "");
    SetDlgItemText(IDC_RUNPROG, m_RunProgram);

    m_RunInvisible = theApp.GetProfileInt("Settings", "Run Invisible", 0);
    CheckDlgButton(IDC_RUNINVISIBLE, (m_RunInvisible != 0));

    m_CfgModified = false;
    GetDlgItem(IDC_SAVECFG)->EnableWindow(false);

    ((CProgressCtrl*)GetDlgItem(IDC_LINKQUALITY))->SetRange(0, 256);

    if ((dllRasHangUp == NULL) || (dllRasEnumConnections == NULL) ||
        (dllRasDialDlg == NULL))
        GetDlgItem(IDC_CONNECT)->EnableWindow(false);

    if (strcmp(theApp.m_lpCmdLine, "/d") == 0)
    {
        if ((GetRASConnHandle()) && (dllRasHangUp != NULL))
            dllRasHangUp(m_hRASConn);
        ExitProcess(0);
    }
    else
    {
        if (OpenCOMPort(false))
        {
            boolean noErr = GetCommModemStatus(m_hCOMPort, &status);

            CloseHandle(m_hCOMPort);

            if (noErr)
            {
                m_AutoMode = true;

                if ((status & MS_CTS_ON) == 0)
                    OnConfigLaser();
                else
                    OnTest();
            }
        }
        else
            if (GetRASConnHandle())
            {
                GetDlgItem(IDC_CONFIG)->EnableWindow(false);
                GetDlgItem(IDC_TEST)->EnableWindow(false);
                SetDlgItemText(IDC_CONNECT, "Trennen");
            }
    }

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CLaserDeskDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CLaserDeskDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CLaserDeskDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLaserDeskDlg::ErrorExit(char *msg)
{
    MessageBox(msg);
    ExitProcess(1);
}

void CLaserDeskDlg::OnChangeCOMPort()
{
    DWORD oldCOMPort = m_COMPortNo;

    m_COMPortNo = ((CComboBox*)GetDlgItem(IDC_COMPORT))->GetCurSel();

    if (m_COMPortNo != oldCOMPort)
    {
        m_CfgModified = true;
	    GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
    }
}

void CLaserDeskDlg::OnChangeBaudrate()
{
    DWORD oldBaudrate = m_Baudrate;

    m_Baudrate = ((CComboBox*)GetDlgItem(IDC_BAUDRATE))->GetCurSel();

    if (m_Baudrate != oldBaudrate)
    {
        m_CfgModified = true;
	    GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
    }
}

void CLaserDeskDlg::OnChangeSensitivity()
{
    DWORD oldSensitivity = m_Sensitivity;

    m_Sensitivity = ((CComboBox*)GetDlgItem(IDC_SENSITIVITY))->GetCurSel();

    if (m_Sensitivity != oldSensitivity)
    {
        m_CfgModified = true;
	    GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
    }
}

void CLaserDeskDlg::OnChangeRASLinkName()
{
    GetDlgItemText(IDC_RASLINKNAME, m_RASLinkName);

    m_CfgModified = true;
    GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
}

void CLaserDeskDlg::OnChangeRunProg()
{
    GetDlgItemText(IDC_RUNPROG, m_RunProgram);

    m_CfgModified = true;
    GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
}

void CLaserDeskDlg::OnBrowse() 
{
    CFileDialog fileDlg(true, NULL, m_RunProgram, OFN_HIDEREADONLY, NULL, this);

    fileDlg.m_ofn.lpstrTitle = "Programm whlen";
    if (fileDlg.DoModal() == IDOK)
    {
        m_RunProgram = fileDlg.GetPathName();
        SetDlgItemText(IDC_RUNPROG, m_RunProgram);

        m_CfgModified = true;
        GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
    }
}

void CLaserDeskDlg::OnRunInvisible()
{
    m_RunInvisible = IsDlgButtonChecked(IDC_RUNINVISIBLE);

    m_CfgModified = true;
    GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
}

void CLaserDeskDlg::OnSaveCfg()
{
	theApp.WriteProfileInt("Settings", "COM Port", m_COMPortNo);
	theApp.WriteProfileInt("Settings", "Baudrate", m_Baudrate);
    theApp.WriteProfileInt("Settings", "Sensitivity", m_Sensitivity);
    theApp.WriteProfileString("Settings", "RAS Link Name", m_RASLinkName);
    theApp.WriteProfileString("Settings", "Run Program", m_RunProgram);
    theApp.WriteProfileInt("Settings", "Run Invisible", m_RunInvisible);

    m_CfgModified = false;
    GetDlgItem(IDC_SAVECFG)->EnableWindow(false);
}

void CLaserDeskDlg::OnConfigLaser()
{
    if (m_pLaserConfigThread == NULL)
    {
        m_pLaserConfigThread = AfxBeginThread(ConfigureLaser, this);
        GetDlgItem(IDC_COMPORT)->EnableWindow(false);
        GetDlgItem(IDC_BAUDRATE)->EnableWindow(false);
        GetDlgItem(IDC_SENSITIVITY)->EnableWindow(false);
        GetDlgItem(IDC_RASLINKNAME)->EnableWindow(false);
        GetDlgItem(IDC_RUNPROG)->EnableWindow(false);
        GetDlgItem(IDC_BROWSE)->EnableWindow(false);
        GetDlgItem(IDC_RUNINVISIBLE)->EnableWindow(false);
        GetDlgItem(IDC_SAVECFG)->EnableWindow(false);
        SetDlgItemText(IDC_CONFIG, "Abbrechen");
        GetDlgItem(IDC_TEST)->EnableWindow(false);
        GetDlgItem(IDC_CONNECT)->EnableWindow(false);
    }
    else
    {
        TerminateThread(m_pLaserConfigThread->m_hThread, 0);
        m_pLaserConfigThread = NULL;

        CloseHandle(m_hCOMPort);
        m_hCOMPort = INVALID_HANDLE_VALUE;

        OnConfigDone(false);
        SetDlgItemText(IDC_STATUSBAR, "");
    }
}

void CLaserDeskDlg::OnTest()
{
    if (m_pLaserTestThread == NULL)
    {
        m_pLaserTestThread = AfxBeginThread(TestLaser, this);
        GetDlgItem(IDC_COMPORT)->EnableWindow(false);
        GetDlgItem(IDC_BAUDRATE)->EnableWindow(false);
        GetDlgItem(IDC_SENSITIVITY)->EnableWindow(false);
        GetDlgItem(IDC_RASLINKNAME)->EnableWindow(false);
        GetDlgItem(IDC_RUNPROG)->EnableWindow(false);
        GetDlgItem(IDC_BROWSE)->EnableWindow(false);
        GetDlgItem(IDC_RUNINVISIBLE)->EnableWindow(false);
        GetDlgItem(IDC_SAVECFG)->EnableWindow(false);
        GetDlgItem(IDC_CONFIG)->EnableWindow(false);
        SetDlgItemText(IDC_TEST, "Abbrechen");
        GetDlgItem(IDC_CONNECT)->EnableWindow(false);
    }
    else
    {
        TerminateThread(m_pLaserTestThread->m_hThread, 0);
        m_pLaserTestThread = NULL;

        CloseHandle(m_hCOMPort);
        m_hCOMPort = INVALID_HANDLE_VALUE;

        OnTestDone(false);
        SetDlgItemText(IDC_STATUSBAR, "");
    }
}

void CLaserDeskDlg::OnConnect()
{
    RASDIALDLG dialData;

    dialData.dwSize     = sizeof(RASDIALDLG);
    dialData.hwndOwner  = m_hWnd;
    dialData.dwFlags    = 0;
    dialData.dwSubEntry = 0;
    dialData.reserved   = 0;
    dialData.reserved2  = 0;

    if (m_hRASConn == NULL)
    {
        if (dllRasDialDlg != NULL)
        {
            if (dllRasDialDlg(NULL, m_RASLinkName.GetBuffer(0), NULL, &dialData))
            {
                if (m_RunProgram != "")
                {
                    STARTUPINFO startup;
                    PROCESS_INFORMATION processInfo;

                    ZeroMemory(&startup, sizeof(STARTUPINFO));
                    startup.cb = sizeof(STARTUPINFO);
                    if (m_RunInvisible)
                        startup.dwFlags     = STARTF_USESHOWWINDOW;
                        startup.wShowWindow = SW_HIDE;

                    if (!CreateProcess(NULL, m_RunProgram.GetBuffer(0), NULL, NULL, false,
                                       0, NULL, NULL, &startup, &processInfo))
                    {
                        CString msg = "Kann " + m_RunProgram + " nicht ausfhren!\n";
                        ErrorExit(msg.GetBuffer(0));
                    }
                }

                GetRASConnHandle();
                GetDlgItem(IDC_CONFIG)->EnableWindow(false);
                GetDlgItem(IDC_TEST)->EnableWindow(false);
                SetDlgItemText(IDC_CONNECT, "Trennen");

                if (m_AutoMode)
                    ExitProcess(0);
            }
        }
    }
    else
    {
        if (dllRasHangUp != NULL)
        {
            SetDlgItemText(IDC_STATUSBAR, "Trenne Verbindung...");
            dllRasHangUp(m_hRASConn);
            SetDlgItemText(IDC_STATUSBAR, "");

            if (!GetRASConnHandle())
            {
                GetDlgItem(IDC_CONFIG)->EnableWindow(true);
                GetDlgItem(IDC_TEST)->EnableWindow(true);
                SetDlgItemText(IDC_CONNECT, "Verbinden");
            }
        }
    }

    m_AutoMode = false;
}

boolean CLaserDeskDlg::OpenCOMPort(boolean errMsg)
{
    char PortName[] = "COM :";

    PortName[3] = '1' + m_COMPortNo;
    m_hCOMPort = CreateFile(PortName, GENERIC_READ + GENERIC_WRITE, 0, NULL, OPEN_EXISTING,
                            FILE_ATTRIBUTE_NORMAL, NULL);
    if (m_hCOMPort == INVALID_HANDLE_VALUE)
    {
        if (errMsg)
        {
            static char errorMsg[] = "FEHLER: Serieller Port COM?: ist nicht verfgbar";

            errorMsg[26] = '1' + m_COMPortNo;
            SetDlgItemText(IDC_STATUSBAR, errorMsg);
        }

        return false;
    }

    return true;
}

boolean CLaserDeskDlg::GetRASConnHandle()
{
    RASCONN* buf;
    DWORD    size;
    DWORD    connections;
    DWORD    n;

    m_hRASConn = NULL;
    if (dllRasEnumConnections != NULL)
    {
        buf           = new RASCONN[1];
        buf[0].dwSize = sizeof(RASCONN);
        size          = sizeof(RASCONN);
        dllRasEnumConnections(buf, &size, &connections);
        if (size > 0)
        {
            delete buf;
            buf = (RASCONN*)new BYTE[size];
            buf[0].dwSize = sizeof(RASCONN);
            if (dllRasEnumConnections(buf, &size, &connections) == 0)
            {
                for (n = 0; n < connections; n++)
                    if (m_RASLinkName.CompareNoCase(buf[n].szEntryName) == 0)
                    {
                        m_hRASConn = buf[n].hrasconn;
                        return true;
                    }
            }
        }
    }

    return false;
}

void CLaserDeskDlg::OnConfigDone(boolean success)
{
    m_pLaserConfigThread = NULL;

    GetDlgItem(IDC_COMPORT)->EnableWindow(true);
    GetDlgItem(IDC_BAUDRATE)->EnableWindow(true);
    GetDlgItem(IDC_SENSITIVITY)->EnableWindow(true);
    GetDlgItem(IDC_RASLINKNAME)->EnableWindow(true);
    GetDlgItem(IDC_RUNPROG)->EnableWindow(true);
    GetDlgItem(IDC_BROWSE)->EnableWindow(true);
    GetDlgItem(IDC_RUNINVISIBLE)->EnableWindow(true);
    if (m_CfgModified)
        GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
    SetDlgItemText(IDC_CONFIG, "Konfigurieren");
    GetDlgItem(IDC_TEST)->EnableWindow(true);
    GetDlgItem(IDC_CONNECT)->EnableWindow(true);

    if (success && m_AutoMode)
        OnTest();
    else
        m_AutoMode = false;
}

void CLaserDeskDlg::OnTestDone(boolean success)
{
    m_pLaserTestThread = NULL;

    ((CProgressCtrl*)GetDlgItem(IDC_LINKQUALITY))->SetPos(0);
    
    GetDlgItem(IDC_COMPORT)->EnableWindow(true);
    GetDlgItem(IDC_BAUDRATE)->EnableWindow(true);
    GetDlgItem(IDC_SENSITIVITY)->EnableWindow(true);
    GetDlgItem(IDC_RASLINKNAME)->EnableWindow(true);
    GetDlgItem(IDC_RUNPROG)->EnableWindow(true);
    GetDlgItem(IDC_BROWSE)->EnableWindow(true);
    GetDlgItem(IDC_RUNINVISIBLE)->EnableWindow(true);
    if (m_CfgModified)
        GetDlgItem(IDC_SAVECFG)->EnableWindow(true);
    GetDlgItem(IDC_CONFIG)->EnableWindow(true);
    SetDlgItemText(IDC_TEST, "Testen");
    GetDlgItem(IDC_CONNECT)->EnableWindow(true);

    if (success && m_AutoMode)
        OnConnect();
    else
        m_AutoMode = false;
}

UINT ConfigureLaser(LPVOID pLaserDeskDlg)
{
    #define pThis ((CLaserDeskDlg*)pLaserDeskDlg)

    DWORD status;
    DWORD event;
    DWORD bytes;
    DCB   dcb;
    BYTE  cfgData[8] = {0x0B, 0x51, 0x00, 0x70, 0x43, 0x00, 0x90, 0x11};
    BYTE  echoBuf[8];
    BYTE  BaudrateEncoding[4] = {0x8B, 0x89, 0x83, 0x81};

    if (!pThis->OpenCOMPort(true))
    {
        pThis->OnConfigDone(false);
        return 0;
    }

    try
    {
        if (!SetCommMask(pThis->m_hCOMPort, EV_CTS))
            throw 1;

        if (!GetCommModemStatus(pThis->m_hCOMPort, &status))
            throw 2;

        if ((status & MS_CTS_ON) != 0)
        {
            pThis->SetDlgItemText(IDC_STATUSBAR, "Laser-Transceiver zuerst ausschalten");

            while ((status & MS_CTS_ON) != 0)
            {
                if (!WaitCommEvent(pThis->m_hCOMPort, &event, NULL))
                    throw 3;
                if (!GetCommModemStatus(pThis->m_hCOMPort, &status))
                    throw 4;
            }
        }

        pThis->SetDlgItemText(IDC_STATUSBAR, "Laser-Transceiver einschalten");
        while ((status & MS_CTS_ON) == 0)
        {
            if (!WaitCommEvent(pThis->m_hCOMPort, &event, NULL))
                throw 5;
            if (!GetCommModemStatus(pThis->m_hCOMPort, &status))
                throw 6;
        }

        pThis->SetDlgItemText(IDC_STATUSBAR, "Sende Konfigurationsdaten...");

        if (!GetCommState(pThis->m_hCOMPort, &dcb))
            throw 7;
        dcb.BaudRate      = 9600;
        dcb.ByteSize      = 8;
        dcb.Parity        = NOPARITY;
        dcb.StopBits      = ONESTOPBIT;
        dcb.fInX          = false;
        dcb.fOutX         = false;
        dcb.fOutxCtsFlow  = false;
        dcb.fOutxDsrFlow  = false;
        dcb.fNull         = false;
        dcb.fDtrControl   = DTR_CONTROL_DISABLE;
        dcb.fRtsControl   = RTS_CONTROL_DISABLE;
        if (!SetCommState(pThis->m_hCOMPort, &dcb))
            throw 8;

        COMMTIMEOUTS timeouts = {0, 0, 100, 0, 0};
        if (!SetCommTimeouts(pThis->m_hCOMPort, &timeouts))
            throw 9;

        cfgData[2] = 0x61 + pThis->m_Sensitivity;
        cfgData[5] = BaudrateEncoding[pThis->m_Baudrate];

        Sleep(500);

        if ((!WriteFile(pThis->m_hCOMPort, cfgData, sizeof(cfgData), &bytes, NULL)) ||
            (bytes < sizeof(cfgData)))
            throw 10;
        if (!ReadFile(pThis->m_hCOMPort, echoBuf, sizeof(cfgData), &bytes, NULL))
            throw 11;
        if ((bytes < sizeof(cfgData)) || (memcmp(cfgData, echoBuf, sizeof(cfgData)) != 0))
        {
            pThis->SetDlgItemText(IDC_STATUSBAR,
                                  "FEHLER: Konfigurationsdaten wurden nicht empfangen");

            CloseHandle(pThis->m_hCOMPort);
            pThis->m_hCOMPort = INVALID_HANDLE_VALUE;

            pThis->OnConfigDone(false);
            return 0;
        }

        pThis->SetDlgItemText(IDC_STATUSBAR, "Warten, bis Transceiver bereit ist...");

        dcb.BaudRate = Baudrates[pThis->m_Baudrate];
        if (!SetCommState(pThis->m_hCOMPort, &dcb))
            throw 8;

        do
        {
            if ((!WriteFile(pThis->m_hCOMPort, cfgData, 1, &bytes, NULL)) ||
                (bytes < 1))
                throw 13;
            if (!ReadFile(pThis->m_hCOMPort, echoBuf, 1, &bytes, NULL))
                throw 14;
        } while (bytes == 1);

        pThis->SetDlgItemText(IDC_STATUSBAR, "");
    }
    catch (int pos)
    {
        char msg[30];

        sprintf(msg, "Interner Fehler %d\n", pos);
        pThis->ErrorExit(msg);
    }

    CloseHandle(pThis->m_hCOMPort);
    pThis->m_hCOMPort = INVALID_HANDLE_VALUE;

    pThis->OnConfigDone(true);
    return 0;
}

UINT TestLaser(LPVOID pLaserDeskDlg)
{
    #define pThis ((CLaserDeskDlg*)pLaserDeskDlg)

    DWORD status;
    DWORD bytes;
    DCB   dcb;
    char  testStr[] = "TESTTESTTESTTEST";
    BYTE  echoBuf[1024];
    BYTE* bufOffs;
    DWORD sent, received;
    DWORD startTime, diffTime;
    int   i;

    if (!pThis->OpenCOMPort(true))
    {
        pThis->OnTestDone(false);
        return 0;
    }

    try
    {
        if (!SetCommMask(pThis->m_hCOMPort, EV_CTS))
            throw 15;

        if (!GetCommModemStatus(pThis->m_hCOMPort, &status))
            throw 16;

        if ((status & MS_CTS_ON) == 0)
        {
            pThis->SetDlgItemText(IDC_STATUSBAR,
                                  "FEHLER: Laser-Transceiver ist nicht eingeschaltet");

            CloseHandle(pThis->m_hCOMPort);
            pThis->m_hCOMPort = INVALID_HANDLE_VALUE;

            pThis->OnTestDone(false);
            return 0;
        }

        if (!GetCommState(pThis->m_hCOMPort, &dcb))
            throw 3;
        dcb.BaudRate      = Baudrates[pThis->m_Baudrate];
        dcb.ByteSize      = 8;
        dcb.Parity        = NOPARITY;
        dcb.StopBits      = ONESTOPBIT;
        dcb.fInX          = false;
        dcb.fOutX         = false;
        dcb.fOutxCtsFlow  = false;
        dcb.fOutxDsrFlow  = false;
        dcb.fNull         = false;
        dcb.fDtrControl   = DTR_CONTROL_DISABLE;
        dcb.fRtsControl   = RTS_CONTROL_DISABLE;
        if (!SetCommState(pThis->m_hCOMPort, &dcb))
            throw 17;

        COMMTIMEOUTS timeouts = {0, 0, 1, 0, 0};
        if (!SetCommTimeouts(pThis->m_hCOMPort, &timeouts))
            throw 18;

        if (pThis->m_AutoMode)
            pThis->SetDlgItemText(IDC_STATUSBAR, "Prfe Link-Qualitt...");
        else
            pThis->SetDlgItemText(IDC_STATUSBAR, "Der Laser ist eingeschaltet");

        startTime = GetTickCount();
        while (true)
        {
            sent     = 0;
            received = 0;

            for (i = 0; i < 64; i++)
            {
                if (!WriteFile(pThis->m_hCOMPort, testStr, 16, &bytes, NULL))
                    throw 19;
            }
            sent += 256;

            if (!ReadFile(pThis->m_hCOMPort, echoBuf, 1024, &bytes, NULL))
                throw 20;

            bufOffs = echoBuf;
            while (bytes >= 4)
            {
                if (memcmp(testStr, bufOffs, 4) == 0)
                {
                    received++;
                    bytes  -= 4;
                    bufOffs += 4;
                }
                else
                {
                    bytes--;
                    bufOffs++;
                }
            }
            if (!PurgeComm(pThis->m_hCOMPort, PURGE_TXCLEAR + PURGE_RXCLEAR))
                throw 21;

            ((CProgressCtrl*)pThis->GetDlgItem(IDC_LINKQUALITY))->SetPos(received);

            if (pThis->m_AutoMode)
            {
                diffTime = GetTickCount() - startTime;
                if ((diffTime >= 1000) && ((received*100)/sent < 90))
                {
                    pThis->m_AutoMode = false;
                    pThis->SetDlgItemText(IDC_STATUSBAR, "Schlechte Verbindung - Ausrichten erforderlich");
                }
                if (diffTime >= 6000)
                    break;
            }
        }
    }
    catch (int pos)
    {
        char msg[30];

        sprintf(msg, "Interner Fehler %d\n", pos);
        pThis->ErrorExit(msg);
    }

    CloseHandle(pThis->m_hCOMPort);
    pThis->m_hCOMPort = INVALID_HANDLE_VALUE;

    pThis->SetDlgItemText(IDC_STATUSBAR, "");
    pThis->OnTestDone(true);
    return 0;
}
